#ifndef __WINDOW_H__
#define __WINDOW_H__

#include <QtGui>

class Widget3D;

/**
 * Window
 * @author Stphane GINIER
 */
class Window : public QMainWindow
{
    Q_OBJECT

public:
    Window();
    ~Window();
    QPushButton* getColorButton();
    QButtonGroup *getShaderButtonGroup();

private:
    void keyPressEvent(QKeyEvent *event);
    void keyReleaseEvent(QKeyEvent *event);
    void initSculptDock();
    void initMeshDock();
    void initMenu();
    Widget3D *widget_; //widget
    QDockWidget *sculptDock_; //sculpt tools dock
    QDockWidget *meshDock_; //camera and shaders dock
    QButtonGroup *shaderButtonGroup_; //shader selection
    QPushButton *colorButton_; //change mesh color
};
#endif /*__FENETRE_PRINCIPALE_H__*/
