#ifndef __TRIANGLE_H__
#define __TRIANGLE_H__

#include <QVector3D>
#include "Aabb.h"

class Octree;

/**
 * Triangle
 * @author Stphane GINIER
 */
class Triangle
{
public:
    static int tagMask_; //flag mask value (always >= tagFlag_)
    int tagFlag_; //general purpose flag (<0 means the triangle is to be deleted)
    int stateFlag_; //flag for history

public:
    Triangle(const QVector3D &n = QVector3D(),int iVer1 = -1, int iVer2 = -1, int iVer3 = -1, int id = -1);
    ~Triangle();
    void replaceVertex(int iVerOld, int iVerNew);

public:
    int id_; //id
    int vIndices_[3]; //indices of vertices
    QVector3D normal_; //normal of triangle
    Aabb aabb_; //bounding box of the triangle
    Octree *leaf_; //octree leaf
    int posInLeaf_; //position index in the leaf
};

#endif /*__TRIANGLE_H__*/
