#ifndef __FILES_H__
#define __FILES_H__

#include <fstream>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include "Mesh.h"
#include "Window.h"

/**
 * Handle files (import/export)
 * @author Stphane GINIER
 */
class Files
{

public:
    Files();
    ~Files();
    Mesh* loadSTL(const std::string &filepath, Window *window) const;
    int detectNewVertex(const Vertex &v, int iTri, std::set<Vertex> &setVertices, std::vector<Vertex> &vertices) const;
    void saveSTL(Mesh *mesh, const std::string &filename, Window *window) const;

    Mesh* loadOBJ(const std::string &filepath, Window *window) const;

    Mesh* load3DS(const std::string &filepath, Window *window) const;
};

#endif /*__FILES_H__*/
