#ifndef __TOOLS_H__
#define __TOOLS_H__

#include <QMatrix4x4>
#include <vector>
#include <algorithm>
#include <iostream>

/**
 * Tools
 * @author Stphane GINIER
 */
namespace Tools
{
    /** Sort and delete duplicate values */
    template<typename T> void tidy(std::vector<T> &vec)
    {
        std::sort(vec.begin(), vec.end());
        vec.resize(std::unique(vec.begin(), vec.end())-vec.begin());
    }

    void coutMatrix(const QMatrix4x4 &matrix);
    void coutVertex(const QVector3D &vertex);
}

#endif /*__TOOLS_H__*/
