varying vec3 vVertex;
varying vec3 vNormal;

uniform vec4 color;
uniform sampler2D reflectionTexture;

uniform vec3 centerPicking;
uniform float radiusSquared;

void main()
{
	vec2 vTexCoord = vNormal.xy * 0.5 + vec2(0.5, 0.5);
    vec4 texel = texture2D(reflectionTexture, vTexCoord);
    gl_FragColor = texel;

    //stolen from sculptris , sorry :D
    //vec4 multfactor = gl_FragColor*2;
    //vec4 screenfactor = multfactor - vec4(1,1,1,1);
    //multfactor = min(multfactor, vec4(1,1,1,1));
    //screenfactor = max(screenfactor, vec4(0,0,0,0));
    //gl_FragColor = multfactor - (vec4(1,1,1,1) - gl_FragColor) * (vec4(1,1,1,1) - screenfactor)*multfactor;

    vec3 vecDistance = vVertex-centerPicking;
    float dotSquared = dot(vecDistance,vecDistance);
    if(dotSquared<radiusSquared*1.06 && dotSquared>radiusSquared*0.94)
        gl_FragColor = gl_FragColor*0.5;
    else if(dotSquared<radiusSquared)
        gl_FragColor = gl_FragColor*1.1;
}
