//from 'Single-pass Wireframe Rendering' method
noperspective varying vec3 dist;
varying vec3 vVertex;

uniform vec4 color;
uniform vec3 centerPicking;
uniform float radiusSquared;

const vec4 colorBackface = vec4(0.811, 0.709, 0.231, 1.0);

void main(void)
{
    vec4 colorBis;
    if(!gl_FrontFacing)
        colorBis=colorBackface;
    else
        colorBis=color;

    float d = min(dist[0],min(dist[1],dist[2]));
    float I = exp2(-2*d*d);
    gl_FragColor = I*colorBis/2 + (1.0 - I)*colorBis;

    vec3 vecDistance = vVertex-centerPicking;
    float dotSquared = dot(vecDistance,vecDistance);
    if(dotSquared<radiusSquared*1.06 && dotSquared>radiusSquared*0.94)
        gl_FragColor = gl_FragColor*0.5;
    else if(dotSquared<radiusSquared)
        gl_FragColor = gl_FragColor*1.1;
}
