varying vec3 vNormal;
varying vec3 vVertex;

uniform vec3 lightPosition;
uniform vec4 color;

uniform vec3 centerPicking;
uniform float radiusSquared;

void main ()
{
    vec4 specularColor=color*0.5;
    specularColor.a=color.a*3.0;
    vec3 reflect = -reflect(normalize(vec3(gl_ModelViewMatrix * vec4(lightPosition, 1.0))), vNormal);
    float specular = max(dot(-normalize(vVertex), reflect), 0.0);

    gl_FragColor = color + specularColor*(specular+pow(specular, 10.0));

    vec3 vecDistance = vVertex-centerPicking;
    float dotSquared = dot(vecDistance,vecDistance);
    if(dotSquared<radiusSquared*1.06 && dotSquared>radiusSquared*0.94)
        gl_FragColor = gl_FragColor*0.5;
    else if(dotSquared<radiusSquared)
        gl_FragColor = gl_FragColor*1.1;
}
