attribute vec4 vertex;
attribute vec3 normal;
attribute vec2 texCoord;

varying vec3 vNormal;
varying vec3 vVertex;
varying vec2 vTexCoord;

uniform mat4 modelViewProjectionMatrix;
uniform mat4 modelViewMatrix;
uniform mat3 normalMatrix;

void main()
{
    vNormal = normalMatrix*normal;
    vVertex = vec3(modelViewMatrix*vertex);
    vTexCoord = texCoord;
    gl_Position = modelViewProjectionMatrix*vertex;
}
